/*************************************************************************
 *
 * ADOBE CONFIDENTIAL
 * ___________________
 *
 * Copyright 2012 Adobe Systems Incorporated
 * All Rights Reserved.
 *
 * NOTICE: All information contained herein is, and remains
 * the property of Adobe Systems Incorporated and its suppliers,
 * if any. The intellectual and technical concepts contained
 * herein are proprietary to Adobe Systems Incorporated and its
 * suppliers and are protected by trade secret or copyright law.
 * Dissemination of this information or reproduction of this material
 * is strictly forbidden unless prior written permission is obtained
 * from Adobe Systems Incorporated.
 *
 **************************************************************************/

function Field(name)
{
    this.name = name;
};

Field.prototype = 
{
    get value()
    {
    	var val = window._field.getValue(this.name);
    	
    	if (window._field.isNumberFormatType(this.name) && val != "")
    		val = parseFloat(val);
    		
    	return val;
    },
    
    set value(_val)
    {
    	window._field.setValue(_val, this.name);
    }
};

Field.prototype.getArray = function()
{
	var returnVal;
	
	// get the comma separated field names from native
	var fieldNames = window._field.getArray(this.name);
	
	if (!isNullOrUndefined(fieldNames) && fieldNames.length > 0)
	{
		returnVal = new Array();
		
		// split the comma separate field names and create field object
		// using each field name
		var fieldNameArray = fieldNames.split(",");
		for (var i = 0; i<fieldNameArray.length; i++)
		{
			returnVal[i] = new Field(fieldNameArray[i]);
		}
	}
	return returnVal;
};

Field.prototype.setFocus = function()
{
    window._field.setFocus(this.name);
};
